Unit QSF4R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QSF4R(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; E :Real;
                L1 :Integer; L2 :Integer; var XA :Real);

implementation

procedure QSF4R(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; E :Real;
                L1 :Integer; L2 :Integer; var XA :Real);
var
D,IL,N :Integer;
INT1,INT2,INT3,INT4,I,J,K,EPS,C,W,E1,Z2,H,Z1,P,R,Q,V,T,S,U,Z,BA,BD,BF,
   X,Y,H0,BB,BC :Real;
NI :Boolean;
G :Array [0..4] of Real;
L :Array [0..4] of Real;
M :Array [0..4] of Real;
Q1 :Array [0..4] of Real;
BE :Array [0..6] of Real;
const
SYS051 :Real = 1.192093E-7;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32;
begin
NI := ( A  > B );
EPS := E;
IL := 1;
if (  not ( (NI) ) ) 
 then goto _1;
C := A;
A := B;
B := C;
_1:
W := B-A;
if (  not ( (W  = 0) ) ) 
 then goto _2;
INT1 := 0;
INT2 := 0;
E1 := 0;
goto _32;
_2:
Z2 := E/W;
H := 1;
N := 0;
Z1 := EPS/W;
_3:
P := 0;
E1 := 0;
INT1 := 0;
INT2 := 0;
_4:
R := H/2.0;
Q := W*R;
V := Q*RO;
T := H*0.25;
for D:=1 to 5 do
 begin
  L[D-1] := F(A+W*(P+T*(D-1)));
_5:
 end;
_6:
if ( (L1+L2)  < 1.5  ) and ( V  <= 0.25 ) 
 then goto _7;
S := Abs(L[0]+L[4]-4.0*(L[1]+L[3])+6.0*L[2]);
goto _9;
_7:
I := (A+W*(P+R))*RO+FI;
for D:=1 to 5 do
 begin
  M[D-1] := L[D-1]*Sin(I);
  Q1[D-1] := L[D-1]*Cos(I);
_8:
 end;
I := M[0]+M[4]-4.0*(M[1]+M[3])+6.0*M[2];
S := Q1[0]+Q1[4]-4.0*(Q1[1]+Q1[3])+6.0*Q1[2];
S := EMax1(L1*Abs(I),L2*Abs(S));
_9:
S := S*R*0.42;
if ( Abs(S)-Z1 ) < 0
 then goto _14
 else if ( Abs(S)-Z1 ) > 0
       then goto _10
       else goto _10;
_10:
H := H/2.0;
if ( H-SYS051*P ) < 0
 then goto _11
 else if ( H-SYS051*P ) > 0
       then goto _13
       else goto _11;
_11:
if ( P ) < 0
 then goto _12
 else if ( P ) > 0
       then goto _21
       else goto _12;
_12:
if ( H/4.0 ) < 0
 then goto _21
 else if ( H/4.0 ) > 0
       then goto _13
       else goto _21;
_13:
L[4] := L[2];
L[2] := L[1];
R := H*0.5;
V := W*R*RO;
T := H*0.25;
U := P+T;
L[1] := F(A+W*U);
L[3] := F(A+W*(U+R));
goto _6;
_14:
E1 := E1+Abs(S);
I := (A+W*(P+R))*RO+FI;
Z := Sin(I);
BA := Cos(I);
Q := W*R;
BD := RO*Q;
BE[3] := Sin(BD);
BE[4] := Cos(BD);
if ( BD-0.33 ) < 0
 then goto _15
 else if ( BD-0.33 ) > 0
       then goto _16
       else goto _15;
_15:
BF := BD*0.5;
BE[5] := Sin(BF);
BE[6] := Cos(BF);
G[0] := 0.2666667;
G[1] := 0.7111111*BE[6];
G[2] := 0.1555556*BE[4];
G[3] := 0.7111111*BE[5];
G[4] := 0.1555556*BE[3];
goto _17;
_16:
BE[0] := 1.0/BD;
BE[1] := BE[0]*BE[0];
BE[2] := BE[1]*BE[1];
G[0] := 4.0*BE[1]*(BE[0]*(48.0*BE[1]-19.0)*BE[3]+3.0*(1.0-16.0*
    BE[1])*BE[4]);
G[1] := 32.0*BE[1]*(BE[0]*(5.0-12.0*BE[1])*BE[3]-(1.0-12.0*
    BE[1])*BE[4])/3.0;
G[2] := BE[0]*((3.0-46.0*BE[1]+96.0*BE[2])*BE[3]+2.0*BE[0]*
    (7.0-48.0*BE[1])*BE[4])/3.0;
G[3] := -16.0*BE[1]*((1.0-3.0*BE[1])*BE[3]+3.0*BE[0]*BE[4])/
    3.0;
G[4] := BE[0]*(BE[0]*(11.0-24.0*BE[1])*BE[3]-3.0*(1.0-8.0*
    BE[1])*BE[4])/3.0;
_17:
X := G[0]*L[2]+G[1]*(L[1]+L[3])+G[2]*(L[0]+L[4]);
Y := G[3]*(L[3]-L[1])+G[4]*(L[4]-L[0]);
INT1 := INT1+(Z*X+BA*Y)*R;
INT2 := INT2+(BA*X-Z*Y)*R;
P := P+H;
K := 1.0-P;
N := N+1;
if ( N-1 ) < 0
 then goto _19
 else if ( N-1 ) > 0
       then goto _19
       else goto _18;
_18:
H0 := H;
_19:
if ( 1.0+K/64.0-1.0 ) < 0
 then goto _20
 else if ( 1.0+K/64.0-1.0 ) > 0
       then goto _22
       else goto _20;
_20:
J := (Abs(F(B))+Abs(L[4]))*K/2.0;
if ( J-Z2 ) < 0
 then goto _26
 else if ( J-Z2 ) > 0
       then goto _21
       else goto _26;
_21:
XA := A+P*W;
INT1 := INT1*W;
INT2 := INT2*W;
_QSCOMX.elm1 := XA;
UTQS11(N,6);
goto _32;
_22:
L[0] := L[4];
if ( S-Z1/32.0 ) < 0
 then goto _23
 else if ( S-Z1/32.0 ) > 0
       then goto _24
       else goto _24;
_23:
H := 2.0*H;
_24:
if ( H-K ) < 0
 then goto _4
 else if ( H-K ) > 0
       then goto _25
       else goto _4;
_25:
H := K;
goto _4;
_26:
BB := EMax1(Abs(INT1)*L1,Abs(INT2)*L2);
BB := Z2*(1+BB);
if ( E1-BB ) < 0
 then goto _31
 else if ( E1-BB ) > 0
       then goto _27
       else goto _31;
_27:
if ( IL-1 ) < 0
 then goto _28
 else if ( IL-1 ) > 0
       then goto _28
       else goto _29;
_28:
BC := EMax1((Abs(INT1-INT3)/(1+Abs(INT3))*L1),(Abs(INT2-
    INT4)/(1+Abs(INT4))*L2));
if ( BC-Z2 ) < 0
 then goto _30
 else if ( BC-Z2 ) > 0
       then goto _29
       else goto _30;
_29:
INT3 := INT1;
INT4 := INT2;
IL := 2;
EPS := EPS/IntPower(2,5);
H := H0;
goto _3;
_30:
E1 := BC;
_31:
INT1 := INT1*W;
INT2 := INT2*W;
XA := B;
if (  not ( (NI) ) ) 
 then goto _32;
C := B;
B := A;
A := C;
INT1 := -INT1;
INT2 := -INT2;
_32:
RINT1 := INT1;
RINT2 := INT2;
end;

end.
